*----------------------------------------------------------------------------
* D117 system startup, init and exception processing code
*----------------------------------------------------------------------------
                .section .text
                .align 2
                .org 0x000000

                dc.l    0x00080000         
                dc.l    _CPU_reset_entry_point
                dc.l    _exception_bus_error
                dc.l    _exception_addr_error
                dc.l    _exception_illegal_instr
                dc.l    _exception_zero_div
                dc.l    _exception_chk_instr
                dc.l    _exception_trapv_instr
                dc.l    _exception_priv_violation
                dc.l    _exception_trace_vector
                dc.l    _exception_emu1010
                dc.l    _exception_emu1111
                dc.l    _exc_unused,_exc_unused,_exc_unused
                dc.l    _exception_uninit_int
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exception_spur_int
                dc.l    _exception_autovect_int,_exception_autovect_int
                dc.l    _exception_autovect_int,_exception_autovect_int
                dc.l    _exception_autovect_int,_exception_autovect_int
                dc.l    _exception_autovect_int
                dc.l    _exception_unused_trap0
                dc.l    _exception_unused_trap1
                dc.l    _exception_unused_trap2
                dc.l    _exception_unused_trap3
                dc.l    _exception_unused_trap4
                dc.l    _exception_unused_trap5
                dc.l    _exception_unused_trap6
                dc.l    _exception_unused_trap7
                dc.l    _exception_unused_trap8
                dc.l    _exception_unused_trap9
                dc.l    _exception_unused_trap10
                dc.l    _exception_unused_trap11
                dc.l    _exception_unused_trap12
                dc.l    _exception_unused_trap13
                dc.l    _exception_unused_trap14
                dc.l    _exception_unused_trap15
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exception_unused_irq0
                dc.l    _exception_unused_irq1
                dc.l    _exception_unused_irq2
                dc.l    _exception_unused_irq3
                dc.l    _pctrl_IRQ4_handler
                dc.l    _exception_unused_irq5
                dc.l    _exception_unused_irq6
                dc.l    _video_IRQ7_handler
                dc.l    _exception_unused_irq8
                dc.l    _exception_unused_irq9
                dc.l    _exception_unused_irq10
                dc.l    _exception_unused_irq11
                dc.l    _exception_unused_irq12
                dc.l    _exception_unused_irq13
                dc.l    _exception_unused_irq14
                dc.l    _exception_unused_irq15
                dc.l    _exception_unused_irq16
                dc.l    _exception_unused_irq17
                dc.l    _exception_unused_irq18
                dc.l    _exception_unused_irq19
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
                dc.l    _exc_unused,_exc_unused,_exc_unused,_exc_unused
*----------------------------------------------------------------------------
                .section .text
_CPU_reset_entry_point:

                move.w  #0x2700, %sr 
                movea.l (0), %sp
                jmp     _sys_reset_entry
*----------------------------------------------------------------------------
_exception_bus_error:
                move.w  %sr,_registers_dump+68
                move.l  #_exc02_msg,_exception_msg_ptr
                move.b  #2,_exception_num
                bra.w   _common_exception_handler

_exception_addr_error:
                move.w  %sr,_registers_dump+68
                move.l  #_exc03_msg,_exception_msg_ptr
                move.b  #3,_exception_num
                bra.w   _common_exception_handler

_exception_illegal_instr:
                move.w  %sr,_registers_dump+68
                move.l  #_exc04_msg,_exception_msg_ptr
                move.b  #4,_exception_num
                bra.w   _common_exception_handler

_exception_zero_div:
                move.w  %sr,_registers_dump+68
                move.l  #_exc05_msg,_exception_msg_ptr
                move.b  #5,_exception_num
                bra.w   _common_exception_handler

_exception_chk_instr:
                move.w  %sr,_registers_dump+68
                move.l  #_exc06_msg,_exception_msg_ptr
                move.b  #6,_exception_num
                bra.w   _common_exception_handler

_exception_trapv_instr:
                move.w  %sr,_registers_dump+68
                move.l  #_exc07_msg,_exception_msg_ptr
                move.b  #7,_exception_num
                bra.w   _common_exception_handler

_exception_priv_violation:
                move.w  %sr,_registers_dump+68
                move.l  #_exc08_msg,_exception_msg_ptr
                move.b  #8,_exception_num
                bra.w   _common_exception_handler

_exception_trace_vector:
                move.w  %sr,_registers_dump+68
                move.l  #_exc09_msg,_exception_msg_ptr
                move.b  #9,_exception_num
                bra.w   _common_exception_handler

_exception_emu1010:
                move.w  %sr,_registers_dump+68
                move.l  #_exc10_msg,_exception_msg_ptr
                move.b  #10,_exception_num
                bra.w   _common_exception_handler

_exception_emu1111:
                move.w  %sr,_registers_dump+68
                move.l  #_exc11_msg,_exception_msg_ptr
                move.b  #11,_exception_num
                bra.w   _common_exception_handler

_exception_uninit_int:
                move.w  %sr,_registers_dump+68
                move.l  #_exc15_msg,_exception_msg_ptr
                move.b  #15,_exception_num
                bra.w   _common_exception_handler

_exception_spur_int:
                move.w  %sr,_registers_dump+68
                move.l  #_exc24_msg,_exception_msg_ptr
                move.b  #24,_exception_num
                bra.w   _common_exception_handler

_exception_autovect_int:
                move.w  %sr,_registers_dump+68
                move.l  #_exc25_msg,_exception_msg_ptr
                move.b  #25,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap0:
                move.w  %sr,_registers_dump+68
                move.l  #_exc32_msg,_exception_msg_ptr
                move.b  #32,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap1:
                move.w  %sr,_registers_dump+68
                move.l  #_exc33_msg,_exception_msg_ptr
                move.b  #33,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap2:
                move.w  %sr,_registers_dump+68
                move.l  #_exc34_msg,_exception_msg_ptr
                move.b  #34,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap3:
                move.w  %sr,_registers_dump+68
                move.l  #_exc35_msg,_exception_msg_ptr
                move.b  #35,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap4:
                move.w  %sr,_registers_dump+68
                move.l  #_exc36_msg,_exception_msg_ptr
                move.b  #36,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap5:
                move.w  %sr,_registers_dump+68
                move.l  #_exc37_msg,_exception_msg_ptr
                move.b  #37,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap6:
                move.w  %sr,_registers_dump+68
                move.l  #_exc38_msg,_exception_msg_ptr
                move.b  #38,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap7:
                move.w  %sr,_registers_dump+68
                move.l  #_exc39_msg,_exception_msg_ptr
                move.b  #39,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap8:
                move.w  %sr,_registers_dump+68
                move.l  #_exc40_msg,_exception_msg_ptr
                move.b  #40,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap9:
                move.w  %sr,_registers_dump+68
                move.l  #_exc41_msg,_exception_msg_ptr
                move.b  #41,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap10:
                move.w  %sr,_registers_dump+68
                move.l  #_exc42_msg,_exception_msg_ptr
                move.b  #42,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap11:
                move.w  %sr,_registers_dump+68
                move.l  #_exc43_msg,_exception_msg_ptr
                move.b  #43,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap12:
                move.w  %sr,_registers_dump+68
                move.l  #_exc44_msg,_exception_msg_ptr
                move.b  #44,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap13:
                move.w  %sr,_registers_dump+68
                move.l  #_exc45_msg,_exception_msg_ptr
                move.b  #45,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap14:
                move.w  %sr,_registers_dump+68
                move.l  #_exc46_msg,_exception_msg_ptr
                move.b  #46,_exception_num
                bra.w   _common_exception_handler

_exception_unused_trap15:
                move.w  %sr,_registers_dump+68
                move.l  #_exc47_msg,_exception_msg_ptr
                move.b  #47,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq0:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x40,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq1:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x41,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq2:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x42,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq3:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x43,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq5:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x45,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq6:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x46,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq8:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x48,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq9:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x49,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq10:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x4A,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq11:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x4B,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq12:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x4C,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq13:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x4D,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq14:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x4E,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq15:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x4F,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq16:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x50,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq17:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x51,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq18:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x52,_exception_num
                bra.w   _common_exception_handler

_exception_unused_irq19:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                move.b  #0x53,_exception_num
                bra.w   _common_exception_handler


_exc_unused:
                move.w  %sr,_registers_dump+68
                move.l  #_exc255_msg,_exception_msg_ptr
                move.b  #255,_exception_num
                bra.w   _common_exception_handler

_exc02_msg:     .asciz  "BUS CYCLE ERROR"
_exc03_msg:     .asciz  "ADDRESS ERROR"
_exc04_msg:     .asciz  "INVALID INSTRUCTION OPCODE"
_exc05_msg:     .asciz  "DIVIDE BY ZERO"
_exc06_msg:     .asciz  "CHK INSTRUCTION VECTOR"
_exc07_msg:     .asciz  "TRAPV INSTRUCTION VECTOR"
_exc08_msg:     .asciz  "PRIVILEGE VIOLATION"
_exc09_msg:     .asciz  "TRACE VECTOR"
_exc10_msg:     .asciz  "$AXXX EMULATION VECTOR"
_exc11_msg:     .asciz  "$FXXX EMULATION VECTOR"
_exc15_msg:     .asciz  "UNINITIALIZED INTERRUPT"
_exc24_msg:     .asciz  "SPURIOUS INTERRUPT"
_exc25_msg:     .asciz  "INVALID AUTOVECTOR INTERRUPT"

_exc32_msg:     .asciz  "TRAP #0"
_exc33_msg:     .asciz  "TRAP #1"
_exc34_msg:     .asciz  "TRAP #2"
_exc35_msg:     .asciz  "TRAP #3"
_exc36_msg:     .asciz  "TRAP #4"
_exc37_msg:     .asciz  "TRAP #5"
_exc38_msg:     .asciz  "TRAP #6"
_exc39_msg:     .asciz  "TRAP #7"
_exc40_msg:     .asciz  "TRAP #8"
_exc41_msg:     .asciz  "TRAP #9"
_exc42_msg:     .asciz  "TRAP #10"
_exc43_msg:     .asciz  "TRAP #11"
_exc44_msg:     .asciz  "TRAP #12"
_exc45_msg:     .asciz  "TRAP #13"
_exc46_msg:     .asciz  "TRAP #14"
_exc47_msg:     .asciz  "TRAP #15"

_exc_uirq_msg:  .asciz  "UNUSED IRQ"

_exc255_msg:    .asciz  "UNUSED/RESERVED EXCEPTION"


.align 2
_common_exception_handler:


                move.w  #0x2700, %sr 
                movem.l %d0-%d7/%a0-%a7,_registers_dump
                move.l  %usp,%a0
                move.l  %a0,_registers_dump+64
                pea     0x0F
                jsr     GFX_load_LED_register
                addq.l  #0x04,%sp

 jmp SYS_restart

 _exc_h_hlt:
                bra.s   _exc_h_hlt

*----------------------------------------------------------------------------

                .ascii  "EXCN:"
_exception_num:
                ds.b    1
.align 2
_exception_msg_ptr:
                ds.l    1
_registers_dump:
                ds.l    18
*----------------------------------------------------------------------------












